
#include "stdafx.h"
#include "NeMessenger.h"
#include "InfoUserMgrWnd.h"
#include "NeMessengerDlg.h"
#include "NtalkDragData.h"

IMPLEMENT_DYNAMIC(CInfoUserMgrWnd, CWnd)

CInfoUserMgrWnd::CInfoUserMgrWnd()
{
	// BG
	m_pImgDelete = NULL;
	m_pImgDeleteOver = NULL;

	m_crBG = DEF_USERMGR_BG_COLOR;
	m_crBGOutline = DEF_USERMGR_BG_OUTLINE_COLOR;
	m_crItemBG = DEF_ITEM_BG_COLOR;
	m_crItemOutline = DEF_ITEM_OUTLINE_COLOR;
	m_crItemBGHighlight = DEF_ITEM_BG_HIGHLIGHT_COLOR;
	m_crItemOutlineHighlight = DEF_ITEM_OUTLINE_HIGHLIGHT_COLOR;

	// dimension
	m_rtWnd.SetRectEmpty();
	m_rtBtnAdd.SetRectEmpty();
	m_rtItem.SetRectEmpty();
	
	// font
	_tcscpy_s(m_wszFontName, GetDefaultFontFaceName());// DEF_USERMGR_ITEM_FONT_NAME);
	m_nFontHeight = DEF_USERMGR_ITEM_FONT_HEIGHT;
	m_fontStyle = DEF_USERMGR_ITEM_FONT_STYLE;
	m_crText = DEF_USERMGR_ITEM_FONT_COLOR;

	// tracking
	m_bTracking = FALSE;
	m_nScrollPage=0;
}

CInfoUserMgrWnd::~CInfoUserMgrWnd()
{
}

BEGIN_MESSAGE_MAP(CInfoUserMgrWnd, CWnd)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSEHOVER()
	ON_WM_MOUSELEAVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_SIZE()
	ON_BN_CLICKED(ID_BTN_USERMGR_ADD, OnBtnClickedUserMgrAdd)
	ON_BN_CLICKED(ID_BTN_ARROW_UP, OnBtnClickedArrowUP)
	ON_BN_CLICKED(ID_BTN_ARROW_DOWN, OnBtnClickedArrowDown)
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDBLCLK()
	ON_MESSAGE(UM_USERMGR_ADDUSER, OnUserMgrAddUser)
	ON_MESSAGE(UM_USERMGR_ADDORGUSER, OnUserMgrAddORGUser)

	ON_MESSAGE(UM_USERMGR_ADDMAXUSER, OnUserMgrMaxAddUser)
END_MESSAGE_MAP()

void CInfoUserMgrWnd::ClearUserMgrItemAll()
{
	_usermgr_item_info* pOIInfo = NULL;

	int nCntItem = m_ptrArItem.GetCount();
	for (int i = 0; i < nCntItem; i++)
	{
		pOIInfo = (_usermgr_item_info*)m_ptrArItem.GetAt(i);
		if (!pOIInfo)
			continue;
		delete pOIInfo;
	}
	m_ptrArItem.RemoveAll();
}


void CInfoUserMgrWnd::SetImgDeletePath(CString strFileName, CString strFileNameOver)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgDelete = new Image(strImgPath);

	if (strFileNameOver.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameOver);

	m_pImgDeleteOver = new Image(strImgPath);
}

void CInfoUserMgrWnd::SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText)
{
	_tcscpy_s(m_wszFontName, wszFontName);
	m_nFontHeight = nFontHeight;
	m_fontStyle = style;

	m_crText = crText;
}

CInfoUserMgrWnd::_usermgr_item_info* CInfoUserMgrWnd::AllocUserMgrItem(CString strName, CString strID)
{
	_usermgr_item_info* pUMInfo = new _usermgr_item_info;
	if (!pUMInfo)
		return NULL;

	pUMInfo->strName = strName;
	pUMInfo->strID = strID;

	return pUMInfo;
}

void CInfoUserMgrWnd::AddUserMgrItem(CString strID, CString strName)
{
	_usermgr_item_info* pUMInfo = NULL;
	pUMInfo = AllocUserMgrItem(strName, strID);
	if (!pUMInfo)
		return;

	_usermgr_item_info* pUMInfoLast = NULL;

	int nCntItem = m_ptrArItem.GetSize();
	if (nCntItem > 0)
		pUMInfoLast = (_usermgr_item_info*)m_ptrArItem.GetAt(nCntItem - 1);

	int nItemCY = DEF_ITEM_HEIGHT;
	int nSXItem = m_rtWnd.left + DEF_ITEM_GAP_WIDTH + 1;
	int nSYItem = m_rtWnd.top + DEF_ITEM_GAP_WIDTH + 1;
	if (pUMInfoLast)
	{
		nSXItem = pUMInfoLast->rtItem.right + DEF_ITEM_GAP_WIDTH + 1;
		nSYItem = pUMInfoLast->rtItem.top;
	}

	int nDeleteCX = 0, nDeleteCY = 0;
	if (m_pImgDelete)
	{
		nDeleteCX = m_pImgDelete->GetWidth();
		nDeleteCY = m_pImgDelete->GetHeight();
	}

	CSize szName(0, 0);
	REAL nFontHeight = m_nFontHeight;
	CRect rtItem(0, 0, 500, 500);
	RecalcTextRect(this, pUMInfo->strName, m_wszFontName, nFontHeight, m_fontStyle, rtItem, szName);

	int nCXItem = DEF_ITEM_NAME_LEFT_POS_X + szName.cx + nDeleteCX;	
	int nCYItem = nItemCY;
	pUMInfo->rtItem.SetRect(nSXItem, nSYItem, nSXItem + nCXItem, nSYItem + nCYItem);

	if (pUMInfo->rtItem.right > m_rtItem.right)
	{
		nSYItem += (DEF_ITEM_GAP_WIDTH + DEF_ITEM_HEIGHT);
		nSXItem = m_rtWnd.left + DEF_ITEM_GAP_WIDTH + 1;

		pUMInfo->rtItem.left = nSXItem;
		pUMInfo->rtItem.right = pUMInfo->rtItem.left + DEF_ITEM_NAME_LEFT_POS_X + szName.cx + nDeleteCX;
		pUMInfo->rtItem.top = nSYItem;
		pUMInfo->rtItem.bottom = pUMInfo->rtItem.top + nItemCY;
	}

	pUMInfo->szName = szName;
	pUMInfo->rtName = pUMInfo->rtItem;
	pUMInfo->rtName.left += DEF_ITEM_NAME_LEFT_POS_X;
	pUMInfo->rtName.top += ((pUMInfo->rtItem.Height() - szName.cy) / 2);
	pUMInfo->rtName.bottom = pUMInfo->rtName.top + szName.cy;

	pUMInfo->rtDelete = pUMInfo->rtItem;
	pUMInfo->rtDelete.right = pUMInfo->rtItem.right;
	pUMInfo->rtDelete.left = pUMInfo->rtDelete.right - nDeleteCX;
	pUMInfo->rtDelete.top += ((pUMInfo->rtItem.Height() - nDeleteCX) / 2);
	pUMInfo->rtDelete.bottom = pUMInfo->rtDelete.top + nDeleteCX;

	m_ptrArItem.Add(pUMInfo);

	UpdateWndInfo(pUMInfo);

	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CInfoUserMgrWnd::DeleteUserMgrItem(_usermgr_item_info* pUMInfoDel)
{
	int nCntItem = m_ptrArItem.GetCount();
	_usermgr_item_info* pUMInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pUMInfo = (_usermgr_item_info*)m_ptrArItem.GetAt(i);
		if (!pUMInfo)
			continue;

		if (pUMInfo == pUMInfoDel)
		{
			delete pUMInfo;
			m_ptrArItem.RemoveAt(i);
			break;
		}
	}
	RecalcItemInfo();
}

int CInfoUserMgrWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;


	if (!m_btnAdd.Create(_T(""), WS_CHILD | WS_VISIBLE | BS_OWNERDRAW, CRect(0, 0, 0, 0), this, ID_BTN_USERMGR_ADD))
		return -1;
	m_btnAdd.SetBtnBitmapFile(GetAppImgFile(_T("btn_07_add.bmp")), RGB(255, 0, 255));


	if (!m_btnArrowUP.Create(_T(""), WS_CHILD | WS_VISIBLE | BS_OWNERDRAW, CRect(0, 0, 0, 0), this, ID_BTN_ARROW_UP))
		return -1;
	m_btnArrowUP.SetBtnBitmapFile(GetAppImgFile(_T("btn_arrow_01.bmp")), RGB(255, 0, 255));


	if (!m_btnArrowDown.Create(_T(""), WS_CHILD | WS_VISIBLE | BS_OWNERDRAW, CRect(0, 0, 0, 0), this, ID_BTN_ARROW_DOWN))
		return -1;
	m_btnArrowDown.SetBtnBitmapFile(GetAppImgFile(_T("btn_arrow_02.bmp")), RGB(255, 0, 255));

	return 0;
}

void CInfoUserMgrWnd::OnDestroy()
{

	if (m_pImgDelete)
	{
		delete m_pImgDelete;
		m_pImgDelete = NULL;
	}
	if (m_pImgDeleteOver)
	{
		delete m_pImgDeleteOver;
		m_pImgDeleteOver = NULL;
	}

	if (m_btnAdd.GetSafeHwnd())
		m_btnAdd.DestroyWindow();
	if (m_btnArrowDown.GetSafeHwnd())
		m_btnArrowDown.DestroyWindow();
	if (m_btnArrowUP.GetSafeHwnd())
		m_btnArrowUP.DestroyWindow();

	ClearUserMgrItemAll();

	CWnd::OnDestroy();
}

void CInfoUserMgrWnd::OnBtnClickedUserMgrAdd()
{
	CWnd* pWndParent = GetParent();
	if (pWndParent && pWndParent->GetSafeHwnd())
		pWndParent->SendMessage(UM_USERMGR_ADDUSERBTN, (WPARAM)0, (LPARAM)0);
}
void CInfoUserMgrWnd::OnBtnClickedArrowDown()
{
	BOOL bCanDown = FALSE;
	int nCntItem = m_ptrArItem.GetCount();
	_usermgr_item_info* pUMInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pUMInfo = (_usermgr_item_info*)m_ptrArItem.GetAt(i);
		if (!pUMInfo)
			continue;



		if (pUMInfo->rtItem.top >= GetScrollDiff() + DEF_ITEM_MARGIN_Y + DEF_ONE_SCROLL_PAGE_WIDTH)
		{
			bCanDown = TRUE;
		}
	}
	if(bCanDown)
	{
		m_nScrollPage++;	
	}
	
	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

}

void CInfoUserMgrWnd::OnBtnClickedArrowUP()
{
	if (m_nScrollPage > 0)
		m_nScrollPage--;
	
	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

}

BOOL CInfoUserMgrWnd::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
}

void CInfoUserMgrWnd::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	
	PAINTSTRUCT ps = dc.m_ps;
	int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;

	int nPX = ps.rcPaint.left;
	int nPY = ps.rcPaint.top;

	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	HDC hdc = dc.GetSafeHdc();

	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		ImageAttributes ImgAttr;

		SolidBrush brushBG(m_crBG);
		Pen penBG(m_crBGOutline, 1);
		int nSX = 0, nSY = 0, nCX = 0, nCY = 0;
		nSX = m_rtWnd.left - rtPS.left;
		nSY = m_rtWnd.top - rtPS.top;
		nCX = m_rtWnd.Width();
		nCY = m_rtWnd.Height();
		graph.FillRectangle(&brushBG, nSX, nSY, nCX, nCY);
		graph.DrawRectangle(&penBG, nSX, nSY, nCX - 1, nCY - 1);


		SolidBrush brushItem(m_crItemBG);
		Pen penItem(m_crItemOutline, 1);

		int nCntItem = m_ptrArItem.GetCount();
		_usermgr_item_info* pUMInfo = NULL;
		for (int i = 0; i < nCntItem; i++)
		{
			pUMInfo = (_usermgr_item_info*)m_ptrArItem.GetAt(i);
			if (!pUMInfo)
				continue;
			

			nSX = pUMInfo->rtItem.left - rtPS.left;
			nSY = pUMInfo->rtItem.top - rtPS.top;
			nCX = pUMInfo->rtItem.Width();
			nCY = pUMInfo->rtItem.Height();
			
			if ((pUMInfo->rtItem.top >= GetScrollDiff() + DEF_ITEM_MARGIN_Y) && 
				(pUMInfo->rtItem.top < GetScrollDiff() + DEF_ITEM_MARGIN_Y + DEF_ONE_SCROLL_PAGE_WIDTH))
			{
				brushItem.SetColor(m_crItemBG);
				penItem.SetColor(m_crItemOutline);
				if (pUMInfo->bDown)
				{
					brushItem.SetColor(m_crItemBGHighlight);
					penItem.SetColor(m_crItemOutlineHighlight);
				}
				graph.FillRectangle(&brushItem, nSX, nSY -(m_nScrollPage * 42) , nCX, nCY - 1);

				if (!(pUMInfo->strName.IsEmpty()))
				{
					CRect rtName = pUMInfo->rtName;
					rtName.top -=GetScrollDiff() ;
					rtName.bottom -=GetScrollDiff() ;
					rtName.InflateRect(0, 0, 5, 0);
					rtName.OffsetRect(0, 1);
					DrawTextToDest2(&graph,
						pUMInfo->strName, &rtPS, &rtName,
						m_wszFontName, m_nFontHeight,
						StringAlignmentNear,
						m_fontStyle,
						m_crText);
				}
				
				Image* pImgDelete = NULL;
				if (pUMInfo->bHoverDelete || pUMInfo->bDownDelete)
					pImgDelete = m_pImgDeleteOver;
				else
					pImgDelete = m_pImgDelete;
				CRect rcDelete = pUMInfo->rtDelete;

				rcDelete.top -=GetScrollDiff();
				rcDelete.bottom -=GetScrollDiff() ;
				if (pImgDelete)
					DrawImageToDest(&graph, pImgDelete, &rtPS, &rcDelete, &ImgAttr);
				graph.DrawRectangle(&penItem, nSX, nSY - GetScrollDiff() , nCX, nCY - 1);
			}
		}

		BitBlt(dc.GetSafeHdc(), nPX,nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);
	}

	::DeleteDC(hdcMemory);
}

void CInfoUserMgrWnd::OnMouseMove(UINT nFlags, CPoint point)
{
	point.y += GetScrollDiff();
	int nCntItem = m_ptrArItem.GetCount();
	if (nCntItem <= 0)
		return;

	BOOL bUpdate = FALSE;
	CRect rtUpdate(0, 0, 0, 0);

	_usermgr_item_info* pUMInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pUMInfo = (_usermgr_item_info*)m_ptrArItem.GetAt(i);
		if (!pUMInfo)
			continue;

		BOOL bHoverDelete = FALSE;
		if (pUMInfo->rtDelete.PtInRect(point))
		{
			bHoverDelete = TRUE;
		}

		if (pUMInfo->bHoverDelete != bHoverDelete)
		{
			pUMInfo->bHoverDelete = bHoverDelete;
			rtUpdate.UnionRect(&rtUpdate, &(pUMInfo->rtDelete));
			bUpdate = TRUE;
		}
	}
	if (bUpdate)
		RedrawWindow(&rtUpdate, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

	if (!m_bTracking)
	{
		m_bTracking = TRUE;

		TRACKMOUSEEVENT tme;
		tme.cbSize = sizeof(TRACKMOUSEEVENT);
		tme.dwFlags = TME_HOVER | TME_LEAVE;
		tme.dwHoverTime = 1;
		tme.hwndTrack = GetSafeHwnd();
		TrackMouseEvent(&tme);
	}

	CWnd::OnMouseMove(nFlags, point);
}

void CInfoUserMgrWnd::OnMouseHover(UINT nFlags, CPoint point)
{
	
}

void CInfoUserMgrWnd::OnMouseLeave()
{
	m_bTracking = FALSE;

	BOOL bUpdate = FALSE;
	CRect rtUpdate(0, 0, 0, 0);

	int nCntItem = m_ptrArItem.GetCount();
	_usermgr_item_info* pUMInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pUMInfo = (_usermgr_item_info*)m_ptrArItem.GetAt(i);
		if (!pUMInfo)
			continue;

		BOOL bHoverDelete = FALSE;
		if (pUMInfo->bHoverDelete != bHoverDelete)
		{
			pUMInfo->bHoverDelete = bHoverDelete;
			rtUpdate.UnionRect(&rtUpdate, &(pUMInfo->rtDelete));
			bUpdate = TRUE;
		}
	}
	if (bUpdate)
		RedrawWindow(&rtUpdate, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CInfoUserMgrWnd::OnLButtonDown(UINT nFlags, CPoint point)
{
	point.y += GetScrollDiff();
	int nCntItem = m_ptrArItem.GetCount();
	if (nCntItem <= 0)
		return;

	BOOL bUpdate = FALSE;
	CRect rtUpdate(0, 0, 0, 0);

	BOOL bDownDelete = FALSE;
	_usermgr_item_info* pUMInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pUMInfo = (_usermgr_item_info*)m_ptrArItem.GetAt(i);
		if (!pUMInfo)
			continue;

		pUMInfo->bDownDelete = FALSE;
		if (pUMInfo->rtDelete.PtInRect(point))
		{
			pUMInfo->bDownDelete = TRUE;
			bDownDelete = TRUE;
		}
	}
	if (!bDownDelete)
	{
		for (int i = 0; i < nCntItem; i++)
		{
			pUMInfo = (_usermgr_item_info*)m_ptrArItem.GetAt(i);
			if (!pUMInfo)
				continue;

			BOOL bDown = FALSE;
			if (pUMInfo->rtItem.PtInRect(point))
			{
				bDown = TRUE;
			}

			if (pUMInfo->bDown != bDown)
			{
				pUMInfo->bDown = bDown;
				rtUpdate.UnionRect(&rtUpdate, &(pUMInfo->rtItem));
				if (!bUpdate)
					SetCapture();

				bUpdate = TRUE;
			}
		}
	}
	if (bUpdate)
		RedrawWindow(&rtUpdate, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

	CWnd::OnLButtonDown(nFlags, point);
}

void CInfoUserMgrWnd::OnLButtonUp(UINT nFlags, CPoint point)
{
	ReleaseCapture();
	point.y += GetScrollDiff();

	int nCntItem = m_ptrArItem.GetCount();
	if (nCntItem <= 0)
		return;

	CWnd* pWndParent = GetParent();

	_usermgr_item_info* pUMInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pUMInfo = (_usermgr_item_info*)m_ptrArItem.GetAt(i);
		if (!pUMInfo)
			continue;

		if (pUMInfo->bDownDelete && pUMInfo->rtDelete.PtInRect(point))
		{
			if (pWndParent && pWndParent->GetSafeHwnd())
				pWndParent->SendMessage(UM_USERMGR_DELUSER, (WPARAM)0, (LPARAM)pUMInfo);
			DeleteUserMgrItem(pUMInfo);
			return;
		}
		else if (pUMInfo->bDown && pUMInfo->rtItem.PtInRect(point))
		{
		}
		pUMInfo->bDownDelete = FALSE;
	}

	CWnd::OnLButtonUp(nFlags, point);
}

void CInfoUserMgrWnd::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	point.y += GetScrollDiff();
	int nCntItem = m_ptrArItem.GetCount();
	if (nCntItem <= 0)
		return;

	CWnd* pWndParent = GetParent();

	_usermgr_item_info* pUMInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pUMInfo = (_usermgr_item_info*)m_ptrArItem.GetAt(i);
		if (!pUMInfo)
			continue;

		if (pUMInfo->rtDelete.PtInRect(point))
		{
		}
		else if (pUMInfo->rtItem.PtInRect(point))
		{
			if (pWndParent && pWndParent->GetSafeHwnd())
				pWndParent->SendMessage(UM_USERMGR_USERINFO, (WPARAM)0, (LPARAM)pUMInfo);
			return;
		}
	}

	CWnd::OnLButtonDblClk(nFlags, point);
}

void CInfoUserMgrWnd::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	m_rtWnd.SetRect(0, 0, cx, cy);
	int nBtnAddImgWidth; 
	int nBtnAddImgHeight;
	int nBtnArrowUpWidth;
	int nBtnArrowUpHeight;
	int nBtnArrowDownWidth;
	int nBtnArrowDownHeight;
	
	int nSX = 0, nSY = 0, nCX = 0, nCY = 0;
	if (m_btnAdd.GetSafeHwnd() && m_btnArrowUP.GetSafeHwnd() && m_btnArrowDown.GetSafeHwnd())
	{
		nBtnAddImgWidth = m_btnAdd.GetImgWidth();
		nBtnAddImgHeight = m_btnAdd.GetImgHeight();
		nBtnArrowUpWidth = m_btnArrowUP.GetImgWidth();
		nBtnArrowUpHeight = m_btnArrowUP.GetImgHeight();
		nBtnArrowDownWidth = m_btnArrowDown.GetImgWidth();
		nBtnArrowDownHeight = m_btnArrowDown.GetImgHeight();


		nSX = m_rtWnd.right - nBtnAddImgWidth;
		nSY = m_rtWnd.bottom - nBtnAddImgHeight;
		m_rtBtnAdd.SetRect(nSX, 0, nSX + nBtnAddImgWidth,  nBtnAddImgHeight);

		m_btnAdd.MoveWindow(&m_rtBtnAdd);
	
	

		CRect rcArrowUP(0, 0, 0, 0);
		CRect rcArrowDown(0, 0, 0, 0);
		rcArrowUP.SetRect(cx - nBtnAddImgWidth - nBtnArrowUpWidth, DEF_ITEM_GAP_WIDTH, cx - nBtnAddImgWidth, nBtnArrowUpHeight + DEF_ITEM_GAP_WIDTH);
		rcArrowDown.SetRect(cx - nBtnAddImgWidth - nBtnArrowDownWidth, nBtnArrowUpHeight + DEF_ITEM_GAP_WIDTH, cx - nBtnAddImgWidth, nBtnArrowUpHeight + nBtnArrowDownHeight + DEF_ITEM_GAP_WIDTH);
		m_btnArrowUP.MoveWindow(&rcArrowUP);
		m_btnArrowDown.MoveWindow(&rcArrowDown);
		m_rtItem = m_rtWnd;
		m_rtItem.right = rcArrowDown.left - 1;
	}

	RecalcItemInfo();
	m_nScrollPage = 0;
}

void CInfoUserMgrWnd::RecalcItemInfo()
{
	CRect rtWndSave = m_rtWnd;

	int nCntItem = m_ptrArItem.GetCount();

	int nSX = m_rtWnd.left + DEF_ITEM_GAP_WIDTH + 1;
	int nSY = m_rtWnd.top + DEF_ITEM_GAP_WIDTH + 1;
	int nItemCY = DEF_ITEM_HEIGHT;
	int nDeleteCX = 0, nDeleteCY = 0;
	if (m_pImgDelete)
	{
		nDeleteCX = m_pImgDelete->GetWidth();
		nDeleteCY = m_pImgDelete->GetHeight();
	}

	_usermgr_item_info* pUMInfo = NULL, *pUMInfoLast = NULL;
	if (nCntItem > 0)
		pUMInfoLast = (_usermgr_item_info*)m_ptrArItem.GetAt(nCntItem - 1);

	for (int i = 0; i < nCntItem; i++)
	{
		pUMInfo = (_usermgr_item_info*)m_ptrArItem.GetAt(i);
		if (!pUMInfo)
			continue;

		pUMInfo->rtItem.left = nSX;
		pUMInfo->rtItem.right = pUMInfo->rtItem.left + DEF_ITEM_NAME_LEFT_POS_X + pUMInfo->szName.cx + nDeleteCX;
		pUMInfo->rtItem.top = nSY;
		pUMInfo->rtItem.bottom = pUMInfo->rtItem.top + nItemCY;

		if (pUMInfo->rtItem.right > m_rtItem.right)
		{
			nSY += (DEF_ITEM_GAP_WIDTH + DEF_ITEM_HEIGHT);
			nSX = m_rtWnd.left + DEF_ITEM_GAP_WIDTH + 1;

			pUMInfo->rtItem.left = nSX;
			pUMInfo->rtItem.right = pUMInfo->rtItem.left + DEF_ITEM_NAME_LEFT_POS_X + pUMInfo->szName.cx + nDeleteCX;
			pUMInfo->rtItem.top = nSY;
			pUMInfo->rtItem.bottom = pUMInfo->rtItem.top + nItemCY;

			nSX += (pUMInfo->rtItem.Width() + DEF_ITEM_GAP_WIDTH + 1);
		}
		else
		{
			nSX += (pUMInfo->rtItem.Width() + DEF_ITEM_GAP_WIDTH + 1);
		}

		pUMInfo->rtName = pUMInfo->rtItem;
		pUMInfo->rtName.left += DEF_ITEM_NAME_LEFT_POS_X;
		pUMInfo->rtName.top += ((pUMInfo->rtItem.Height() - pUMInfo->szName.cy) / 2);
		pUMInfo->rtName.bottom = pUMInfo->rtName.top + pUMInfo->szName.cy;

		pUMInfo->rtDelete = pUMInfo->rtItem;
		pUMInfo->rtDelete.right = pUMInfo->rtItem.right;
		pUMInfo->rtDelete.left = pUMInfo->rtDelete.right - nDeleteCX;
		pUMInfo->rtDelete.top += ((pUMInfo->rtItem.Height() - nDeleteCX) / 2);
		pUMInfo->rtDelete.bottom = pUMInfo->rtDelete.top + nDeleteCX;
	}

	UpdateWndInfo(pUMInfoLast);

	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CInfoUserMgrWnd::UpdateWndInfo(_usermgr_item_info* pUMInfo)
{
	_usermgr_item_info* pUMInfoUpdate = pUMInfo;

	if (!pUMInfoUpdate)
	{
		int nCnt = m_ptrArItem.GetCount();
		if (nCnt <= 0)
			return;
		else
			pUMInfoUpdate = (_usermgr_item_info*)m_ptrArItem.GetAt(nCnt - 1);
	}

	int nNewBottom = pUMInfoUpdate->rtItem.bottom + (2 * DEF_ITEM_GAP_WIDTH);
	if (nNewBottom == m_rtWnd.bottom)
		return;

	int nDiffHeight = nNewBottom - m_rtWnd.bottom;
	m_rtWnd.bottom = DEF_USERMGR_HEIGHT;
	m_rtBtnAdd.bottom = m_rtWnd.bottom;
	if (m_btnAdd.GetSafeHwnd())
		m_rtBtnAdd.top = m_rtBtnAdd.bottom - m_btnAdd.GetImgHeight();

	if (m_btnAdd.GetSafeHwnd())
		m_btnAdd.MoveWindow(&m_rtBtnAdd);

}

BOOL CInfoUserMgrWnd::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	CPoint pt(0, 0);
	GetCursorPos(&pt);
	ScreenToClient(&pt);
	pt.y += m_nScrollPage * DEF_ONE_SCROLL_PAGE_WIDTH;

	_usermgr_item_info* pUMInfo = NULL;

	int nCntItem = m_ptrArItem.GetCount();
	for (int i = 0; i < nCntItem; i++)
	{
		pUMInfo = (_usermgr_item_info*)m_ptrArItem.GetAt(i);
		if (!pUMInfo)
			continue;

		if (pUMInfo->rtDelete.PtInRect(pt))
		{
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_HAND));
			return TRUE;
		}
	}

	return CWnd::OnSetCursor(pWnd, nHitTest, message);
}

LRESULT CInfoUserMgrWnd::OnUserMgrAddUser(WPARAM wParam, LPARAM lParam)
{
	//CNtalkDragData* pNDD = (CNtalkDragData*)lParam;
	IGTBuddyUser *pNDD =  (IGTBuddyUser *)lParam;
	if (!pNDD)
		return 1L;

	AddUserMgrItem(pNDD->GetUserID(), pNDD->GetName());

	return 0L;
}

LRESULT CInfoUserMgrWnd::OnUserMgrAddORGUser(WPARAM wParam, LPARAM lParam){
 
	CNtalkDragData* pNDD = (CNtalkDragData*)lParam;
	if (!pNDD)
		return 1L;

	AddUserMgrItem(pNDD->m_strID, pNDD->m_strName);

	return 0L;
}

// 巡׾ص ߼ο ʰ  [2012.4.18 yangjae.park@nhn.com]
LRESULT CInfoUserMgrWnd::OnUserMgrMaxAddUser(WPARAM wParam, LPARAM lParam)
{
	LRESULT res = (LRESULT)lParam;
	CWnd* pWndParent = GetParent();

	CString strMsg;

	if(res == 1L)		strMsg.LoadString(IDS_STRING296);
	else if(res == 2L)	strMsg.LoadString(IDS_STRING300);
	else if(res == 3L)	strMsg.LoadString(IDS_STRING300);
	else if(res == 4L)	strMsg.LoadString(IDS_STRING298);
	else if(res == 5L)	strMsg.LoadString(IDS_STRING300);
	else if(res == 6L)	strMsg.LoadString(IDS_STRING298);
	else if(res == 7L)	strMsg.LoadString(IDS_STRING300);
	else if(res == 8L)	strMsg.LoadString(IDS_STRING300);

	NMessageBox(pWndParent, strMsg);

	return 0L;
}

